package com.tzld.longarticle.recommend.server.common.enums.recommend;

import lombok.Getter;

import java.util.Objects;

@Getter
public enum RankStrategyEnum {
    ArticleRankV2("ArticleRankV2", "ArticleRankV2", "rankV2Strategy"),
    ArticleRankV3("ArticleRankV3", "ArticleRankV3", "rankV3Strategy"),
    ArticleRankV4("ArticleRankV4", "ArticleRankV4", "rankV4Strategy"),
    ArticleRankV5("ArticleRankV5", "ArticleRankV5", "rankV5Strategy"),
    ArticleRankV6("ArticleRankV6", "ArticleRankV6", "rankV6Strategy"),
    ArticleRankV7("ArticleRankV7", "ArticleRankV7", "rankV7Strategy"),
    ArticleRankV8("ArticleRankV8", "ArticleRankV8", "rankV8Strategy"),
    ArticleRankV9("ArticleRankV9", "ArticleRankV9", "rankV9Strategy"),
    ArticleRankV10("ArticleRankV10", "ArticleRankV10", "rankV10Strategy"),
    ArticleRankV11("ArticleRankV11", "ArticleRankV11", "rankV11Strategy"),
    ArticleRankV12("ArticleRankV12", "ArticleRankV12", "rankV12Strategy"),
    ArticleRankV13("ArticleRankV13", "ArticleRankV13", "rankV13Strategy"),
    ArticleRankV14("ArticleRankV14", "ArticleRankV14", "rankV14Strategy"),

    HIS_JUMP_STRATEGY("ArticleRankHisJump", "历史表现跳过相似度策略", "hisJumpRankStrategy"),
    INFINITE_STRATEGY("ArticleRankInfinite", "无限发表", "infiniteRankStrategy"),
    LATE_STRATEGY("ArticleRankLate", "晚间策略", "lateRankStrategy"),
    RANDOM_STRATEGY("ArticleRankRandom", "随机策略", "randomRankStrategy"),
    DEFAULT_STRATEGY("ArticleRankV1", "默认策略", "defaultRankStrategy"),
    ;

    private final String strategy;
    private final String description;
    private final String taskExecutorName;

    RankStrategyEnum(String strategy, String description, String taskExecutorName) {
        this.strategy = strategy;
        this.description = description;
        this.taskExecutorName = taskExecutorName;
    }

    public static RankStrategyEnum from(String strategy) {
        for (RankStrategyEnum statusEnum : RankStrategyEnum.values()) {
            if (Objects.equals(statusEnum.strategy, strategy)) {
                return statusEnum;
            }
        }
        return DEFAULT_STRATEGY;
    }
}
